from logging import Logger

from discord import ApplicationContext, Bot, Cog, default_permissions, slash_command
from framework.redis import Redis


class Greetings(Cog):
    def __init__(self, bot: Bot, logger: Logger, redis: Redis):
        self.bot = bot
        self.logger = logger
        self.redis = redis

    @slash_command()
    @default_permissions(administrator=True)
    async def redis_set(self, context: ApplicationContext, key: str, value: str):
        self.logger.info(f"redis set {value} at {key}")
        await self.redis.set("test", key, value)

        await context.respond(f"redis set {value} at {key}")

    @slash_command()
    @default_permissions(administrator=True)
    async def redis_get(self, context: ApplicationContext, key: str):
        self.logger.info(f"redis get {key}")
        value = await self.redis.get("test", key)

        await context.respond(f"redis get {key}: {value}")
